QuantLib: LazyObject Class Reference

A free/open-source library for quantitative finance Reference manual - version 1.12

Protected Attributes | List of all members
LazyObject Class Referenceabstract
Design patterns

Framework for calculation on demand and result caching. More...

`#include <ql/patterns/lazyobject.hpp>`

Inherits Observable, and Observer.

Inherited by AbcdAtmVolCurve, AndreasenHugeVolatilityInterpl, Basket, CalibrationHelper, CapFloorTermVolCurve, CapFloorTermVolSurface, CmsMarket, EurodollarFuturesImpliedStdDevQuote, Fdm1DimSolver, Fdm2dBlackScholesSolver, Fdm2DimSolver, Fdm3DimSolver, FdmBatesSolver, FdmBlackScholesSolver, FdmExtOUJumpSolver, FdmG2Solver, FdmHestonHullWhiteSolver, FdmHestonSolver, FdmHullWhiteSolver, FdmKlugeExtOUSolver< N >, FdmNdimSolver< N >, FdmSimple2dBSSolver, FdmSimple2dExtOUSolver, FdmSimple3dExtOUJumpSolver, FittedBondDiscountCurve, FlatForward, ForwardSwapQuote, Gaussian1dModel, HestonSLVFDMModel, HestonSLVMCModel, ImpliedStdDevQuote, Instrument, InterpolatedSmileSection< Interpolator >, LocalVolRNDCalculator, MultiCurveSensitivities, NoArbSabrInterpolatedSmileSection, NormalCLVModel, OneFactorCopula, PiecewiseDefaultCurve< Traits, Interpolator, Bootstrap >, PiecewiseYieldCurve< Traits, Interpolator, Bootstrap >, PiecewiseYoYInflationCurve< Interpolator, Bootstrap, Traits >, PiecewiseYoYOptionletVolatilityCurve< Interpolator, Bootstrap, Traits >, PiecewiseZeroInflationCurve< Interpolator, Bootstrap, Traits >, RandomLM< derivedRandomLM, copulaPolicy, USNG >`[virtual]`, RendistatoCalculator, SabrInterpolatedSmileSection, SquareRootCLVModel, StrippedOptionletAdapter, StrippedOptionletBase, SviInterpolatedSmileSection, SwaptionVolatilityDiscrete, ZabrInterpolatedSmileSection< Evaluation >, RandomLM< RandomDefaultLM, copulaPolicy, USNG >`[virtual]`, and RandomLM< RandomLossLM, copulaPolicy, USNG >`[virtual]`.

## Public Member Functions
Observer interface
void | update ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const boost::shared_ptr< Observable > &)
void | registerWithObservables (const boost::shared_ptr< Observer > &)
Size | unregisterWith (const boost::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()

## Protected Attributes
bool | calculated_
bool | frozen_
bool | alwaysForward_

## Calculations
These methods do not modify the structure of the object and are therefore declared as `const`. Data members which will be calculated on demand need to be declared as mutable.
void | recalculate ()
void | freeze ()
void | unfreeze ()
void | alwaysForwardNotifications ()
virtual void | calculate () const
virtual void | performCalculations () const =0

## Additional Inherited Members
Public Types inherited from Observer
typedef std::set< boost::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator

## Detailed Description

Framework for calculation on demand and result caching.

## Member Function Documentation

## ◆ update()

void update | ( |  | ) |
| virtual

This method must be implemented in derived classes. An instance of Observer does not call this method directly: instead, it will be called by the observables the instance registered with when they need to notify any changes.

Implements Observer.

Reimplemented in PiecewiseDefaultCurve< Traits, Interpolator, Bootstrap >, PiecewiseYieldCurve< Traits, Interpolator, Bootstrap >, FittedBondDiscountCurve, RandomLM< RandomDefaultLM, copulaPolicy, USNG >, RandomLM< RandomLossLM, copulaPolicy, USNG >, CapFloorTermVolCurve, CapFloorTermVolSurface, PiecewiseYoYInflationCurve< Interpolator, Bootstrap, Traits >, PiecewiseZeroInflationCurve< Interpolator, Bootstrap, Traits >, FlatForward, StrippedOptionletAdapter, CmsMarket, and ForwardSwapQuote.

## ◆ recalculate()

void recalculate | ( |  | ) |

This method force the recalculation of any results which would otherwise be cached. It is not declared as `const` since it needs to call the non-`const` notifyObservers method.

Note
  Explicit invocation of this method is not necessary if the object registered itself as observer with the structures on which such results depend. It is strongly advised to follow this policy when possible.

## ◆ freeze()

void freeze | ( |  | ) |

This method constrains the object to return the presently cached results on successive invocations, even if arguments upon which they depend should change.

## ◆ unfreeze()

void unfreeze | ( |  | ) |

This method reverts the effect of the freeze method, thus re-enabling recalculations.

## ◆ alwaysForwardNotifications()

void alwaysForwardNotifications | ( |  | ) |

This method causes the object to forward all notifications, even when not calculated. The default behavior is to forward the first notification received, and discard the others until recalculated; the rationale is that observers were already notified, and don't need further notification until they recalculate, at which point this object would be recalculated too. After recalculation, this object would again forward the first notification received.

Warning:
  Forwarding all notifications will cause a performance hit, and should be used only when discarding notifications cause an incorrect behavior.

## ◆ calculate()

void calculate | ( |  | ) | const
| protectedvirtual

This method performs all needed calculations by calling the performCalculations method.

Warning:
  Objects cache the results of the previous calculation. Such results will be returned upon later invocations of calculate. When the results depend on arguments which could change between invocations, the lazy object must register itself as observer of such objects for the calculations to be performed again when they change.

Warning:
  Should this method be redefined in derived classes, LazyObject::calculate() should be called in the overriding method.

Reimplemented in Instrument.

## ◆ performCalculations()

virtual void performCalculations | ( |  | ) | const
| protectedpure virtual

This method must implement any calculations which must be (re)done in order to calculate the desired results.

Implemented in MarkovFunctional, Gaussian1dModel, Gsr, FixedRateBondForward, Forward, RandomLM< derivedRandomLM, copulaPolicy, USNG >, RandomLM< RandomDefaultLM, copulaPolicy, USNG >, RandomLM< RandomLossLM, copulaPolicy, USNG >, SwaptionVolatilityMatrix, Instrument, AndreasenHugeVolatilityInterpl, CapFloorTermVolCurve, CapFloorTermVolSurface, SwaptionVolatilityCube, RiskyBond, AbcdAtmVolCurve, ConvertibleBond, OptionletStripper1, CompositeInstrument, EnergyVanillaSwap, EnergyBasisSwap, HestonSLVMCModel, StrippedOptionletAdapter, HestonModelHelper, CalibrationHelper, OptionletStripper2, ForwardSwapQuote, EurodollarFuturesImpliedStdDevQuote, ImpliedStdDevQuote, EnergyFuture, and Stock.